/************************************************
 * Virlist Header File with program definitions *
 * Required with VIRLIST.C V1.2 source code.    *
 ************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#ifdef __TURBOC__
#include <conio.h>  /* for getch() prototype */
#endif

char buffer[1024]; /* input buffer */

typedef unsigned char	bool;
typedef unsigned char	FlagType;
typedef unsigned int	WORD;

/* include complete directory for location of text file */
#define VIRLIST_FILE "virlist.txt"

#define TRUE	  1
#define FALSE	  0
#define	NOT_USED  2

/* error codes */
#define ERR_SIZE 1
#define ERR_FLAG 2
#define ERR_OPT  3

enum Size_Flags {   INVALID=0, LESS_THAN=1, LESS_EQUAL=2, EQUAL=3,
		    GREATER_EQUAL=4, GREATER_THAN=5,
		    SIZE_COMPUTED=0, OVERWRITE=-1, VARIES=-2, OTHER=-3,
		    SPAWN=-4, COMPANION=-5, UNKNOWN=-6
		};

/* damage flags */
#define D_BOOT		0x0001
#define D_PROGRAM	0x0002
#define D_DATA		0x0004
#define D_FORMAT	0x0008
#define D_LINKS		0x0010
#define D_OPS		0x0020

WORD enableMask=0, disableMask=0;

char *size_strings[8] = { "<", "<=", "=", ">=", ">",
			  "overwrites", "varies", "spawning" };

/* program option flags */

bool showLegend = TRUE;
long size_value; /* matching size to check */
enum Size_Flags size_code = INVALID;
FlagType flags[10] = {2,2,2,2,2,2,2,2,2,2};	/* init flags as unset */

/* Record storing virus list entry */

struct virEntry
{
	char name[27];		/* Virus name */
	char disinfector[10];	/* Disinfecting program */
	bool codes[10]; 	/* Characteristic codes */
	long size;		/* Size of virus if appropriate */
	int sizecode;           /* size code */
	WORD damage;		/* Damage flag mask */
} virus;


#define MSG_NUM 17	/* Number of messages */

char *messages [MSG_NUM] = {
	"-------------------------------------------------------------------------",
	"B - Corrupts or overwrites the boot sector",
	"P - Corrupts program or overlay files",
	"D - Corrupts data files",
	"F - Formats or overwrites all/part of disk",
	"L - Directly or indirectly corrupts file linkage",
	"O - Affects system run-time operation",

	"1 - Virus Uses STEALTH Techniques",
	"2 - Virus Uses Self-Encryption",
	"3 - Virus Installs Self in Memory",
	"4 - Infects COMMAND.COM",
	"5 - Infects COM files",
	"6 - Infects EXE Files",
	"7 - Infects Overlay Files",
	"8 - Infects Floppy Diskette Boot",
	"9 - Infects Fixed Disk Boot Sector",
	"A - Infects Fixed Disk Partition Table (MBR)"
};


/* Function prototypes */

void Help(int,char*), Legend(void), PrintRecord(void);
void CheckArgs(int, char**), SkipHeader(FILE*);
int  GetRecord(char*);
void CheckCode (int code, char letter);
void SetFlag (int, int, char);
void SetField (WORD flag, short msg_num, char action);

#ifdef QUICK_SEARCH
#define strmatch(s1,s2,len) !strnicmp(s1,s2,len)
#else
int strmatch( char *s1, char *s2, int len );
#endif

/* Macros for GetRecord function */

#define Copy(FIELD, LEN)	strncpy(virus.FIELD, buf, LEN);\
				virus.FIELD[LEN] = 0

#define Damage(FLAG)   virus.damage |= FLAG; break
